using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_Expedientes._1_Datos
{
    public class EPD_Procedimientos_Actores_Datos
    {
        #region Obtener
        public List<long> Obtener_Listado(long _lng_idProcedimiento)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<long> lst_idActor = new List<long>();
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .........................................................
                string str_SQL =
                         " SELECT " +
                             nameof(EPD_Procedimientos_Actores) + "." + nameof(EPD_Procedimientos_Actores.idActor) +
                         " FROM " + nameof(EPD_Procedimientos_Actores) +
                         " WHERE " + nameof(EPD_Procedimientos_Actores.idProcedimiento) + "=@idProcedimiento ";
                // .....................................................................

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idProcedimiento",  _lng_idProcedimiento)
                };

                //Rellenar el Modelo
                lst_idActor = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(EPD_Procedimientos_Actores_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_idActor;
        }
        #endregion

        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Insertar(EPD_Procedimientos_Actores _mdl_EPD_Procedimientos_Actores)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.ProxyCreationEnabled = true;

                string str_SQL_Insertar =  " INSERT INTO " + nameof(EPD_Procedimientos_Actores) + " (" + nameof(EPD_Procedimientos_Actores.idProcedimiento) + "," + nameof(EPD_Procedimientos_Actores.idActor) + "," + nameof(EPD_Procedimientos_Actores.observaciones) + ") values (" + _mdl_EPD_Procedimientos_Actores.idProcedimiento + "," + _mdl_EPD_Procedimientos_Actores.idActor + ",'')";
                
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Insertar);
               
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(EPD_Procedimientos_Actores_Datos) + "/" + nameof(Insertar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public INTERNO_ValorDevuelto_Modelo Borrar(long _lng_idProcedimiento, long _lng_idActor)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                
                string str_SQL_Delete = " DELETE FROM " + nameof(EPD_Procedimientos_Actores) +
                                        " WHERE " +
                                            nameof(EPD_Procedimientos_Actores.idProcedimiento) + "=@idProcedimiento AND " +
                                            nameof(EPD_Procedimientos_Actores.idActor) + "=@idActor ";
                //Parametros
                object[] arr_Parametros_Delete = new object[]
                {
                    new SqlParameter("@idProcedimiento",  _lng_idProcedimiento),
                    new SqlParameter("@idActor", _lng_idActor)
                };

                //Delete
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(EPD_Procedimientos_Actores_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public INTERNO_ValorDevuelto_Modelo Borrar(long _lng_idProcedimiento, List<long> _lst_idActor)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                foreach (long lng_idActor in _lst_idActor)
                {
                    string str_SQL_Delete = " DELETE FROM " + nameof(EPD_Procedimientos_Actores) +
                                            " WHERE " +
                                                nameof(EPD_Procedimientos_Actores.idProcedimiento) + "=@idProcedimiento AND " +
                                                nameof(EPD_Procedimientos_Actores.idActor) + "=@idActor ";
                    //Parametros
                    object[] arr_Parametros_Delete = new object[]
                    {
                        new SqlParameter("@idProcedimiento",  _lng_idProcedimiento),
                        new SqlParameter("@idActor", lng_idActor)
                    };

                    //Delete
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(EPD_Procedimientos_Actores_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {

                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

    }
}
